@echo off
::======================================================================
:: Windows batch file to launch Template Processor (Generator)
::======================================================================

::----------------------------------------------------------------------
:: Specify the location of JRE/JDK 11 (or later) here
::----------------------------------------------------------------------
set JAVA_HOME=C:\Program Files\Java\jdk-17

::----------------------------------------------------------------------
:: Specify the location of FlexDoc/XML home directory.
::
:: If you encounter an error like:
:: 'Exception in thread "main" java.lang.NoClassDefFoundError: xyz/flexdoc/xml/Generator'
:: please specify the absolute pathname of your FlexDoc/XML installation directly, e.g.
::
:: set FDH=C:\flexdoc-xml
::
:: The default setting (below) assigns 'FDH' with the absolute pathname of 
:: this BAT file's parent directory appended with ".."
::----------------------------------------------------------------------
set FDH=%~dp0..

::----------------------------------------------------------------------
:: -Xmx option sets the maximum heap size allocated by JVM.
::
:: Check this option when you need to process large quantities of data!
::
:: Note that allocating too much memory isn't good either because it may actually
:: decrease the performance, especially when that amount of memory isn't backed
:: by the physical RAM on your system.
::
:: The JVM options below set the initial Java heap size to 1024 Mb
:: and allow extending it up to 2048 Mb.
::----------------------------------------------------------------------
set JAVA_OPTIONS=-Xms1024m -Xmx2048m

::----------------------------------------------------------------------
:: FlexDoc/XML module path
::----------------------------------------------------------------------
set MODULE_PATH=%FDH%\lib\flexdoc-xml.jar;%FDH%\lib\xercesImpl.jar

::----------------------------------------------------------------------
:: Run generator with all settings taken from generator.config file
:: (Note: double quotes are needed because file pathnames may contain spaces)
::----------------------------------------------------------------------
"%JAVA_HOME%\bin\java" %JAVA_OPTIONS% --module-path "%MODULE_PATH%" --module flexdoc.xml/xyz.flexdoc.xml.Generator
