<FLEXDOCXYZ_TEMPLATE VER='1.23'>
CREATED='2010-12-18 09:42:02'
LAST_UPDATE='2021-11-28 13:49:11'
DESIGNER_TOOL='FlexDoc.XYZ SDK 1.x'
DESIGNER_LICENSE_TYPE='Filigris Works Team'
APP_ID='flexdoc-xml-wsdldoc'
APP_NAME='FlexDoc/XML WSDLDoc'
APP_VER='1.2.5'
APP_AUTHOR='Copyright © 2012-2021 Filigris Works, Leonid Rudy Softwareprodukte. All rights reserved.'
TEMPLATE_TYPE='DocumentTemplate'
DSM_TYPE_ID='wsdldoc'
ROOT_ET='<ANY>'
<TEMPLATE_PARAMS>
	PARAM={
		param.name='$linkDestKeys';
		param.type='string';
		param.list='true';
		param.defaultValue.expr='Array ("detail", "def", "xml-source-location")';
	}
	PARAM={
		param.name='$targetFrame';
		param.type='string';
	}
	PARAM={
		param.name='$mainXML';
		param.type='GOMElement';
		param.defaultValue.expr='findElementByKey ("main-xmls", getXMLDocument().id)';
	}
	PARAM={
		param.name='$xmlContexts';
		param.description='Specifies an array of one or several alternative elements that determine the XML document context (i.e. the position on the XML document\'s tree) against which the namespace prefix/URI binding will be resolved.';
		param.type='GOMElement';
		param.list='true';
		param.defaultValue.expr='Array (contextElement)';
	}
	PARAM={
		param.name='$redefFull';
		param.type='boolean';
	}
	PARAM={
		param.name='show';
		param.title='Show';
		param.title.style.bold='true';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='show.linkTitle';
		param.title='Link Titles (Tooltips)';
		param.type='boolean';
	}
	PARAM={
		param.name='show.elementNameExt';
		param.title='Element Name Extensions';
		param.type='enum';
		param.enum.values='always;repeating;never';
	}
</TEMPLATE_PARAMS>
<STYLES>
	CHAR_STYLE={
		style.name='Default Paragraph Font';
		style.id='cs1';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Hyperlink';
		style.id='cs2';
		text.decor.underline='true';
		text.color.foreground='#0000FF';
	}
	CHAR_STYLE={
		style.name='Name Extension';
		style.id='cs3';
		text.font.name='Verdana';
		text.font.size='7';
		text.font.style.bold='false';
		text.color.foreground='#B2B2B2';
	}
	CHAR_STYLE={
		style.name='Name Extension Hyperlink';
		style.id='cs4';
		text.decor.underline='true';
	}
	PAR_STYLE={
		style.name='Normal';
		style.id='ps1';
		style.default='true';
	}
</STYLES>
FMT={
	doc.lengthUnits='pt';
	doc.hlink.style.link='cs2';
}
<ROOT>
	<AREA_SEC>
		DESCR='case of global element'
		MATCHING_ET='xs:element'
		BREAK_PARENT_BLOCK='when-executed'
		FMT={
			par.option.nowrap='true';
		}
		<AREA>
			<CTRL_GROUP>
				FMT={
					txtfl.separator.type='none';
				}
				<CTRLS>
					<DATA_CTRL>
						COND='! getAttrBooleanValue ("abstract")'
						EXPR='toXMLName (getServiceAttr("qName").toQName(),
           getArrayParam("$xmlContexts"))'
						<DOC_HLINK>
							TITLE_EXPR='getBooleanParam("show.linkTitle") ? callStockSection("Link Title")'
							TARGET_FRAME_EXPR='getStringParam("$targetFrame")'
							HKEYS={
								'contextElement.id';
								'getArrayParam("$linkDestKeys")';
							}
						</DOC_HLINK>
					</DATA_CTRL>
					<DATA_CTRL>
						COND='getAttrBooleanValue ("abstract")'
						EXPR='toXMLName (getServiceAttr("qName").toQName(),
           getArrayParam("$xmlContexts"))'
						FMT={
							text.font.style.italic='true';
						}
						<DOC_HLINK>
							TITLE_EXPR='getBooleanParam("show.linkTitle") ? callStockSection("Link Title")'
							TARGET_FRAME_EXPR='getStringParam("$targetFrame")'
							HKEYS={
								'contextElement.id';
								'getArrayParam("$linkDestKeys")';
							}
						</DOC_HLINK>
					</DATA_CTRL>
				</CTRLS>
			</CTRL_GROUP>
		</AREA>
	</AREA_SEC>
	<AREA_SEC>
		DESCR='case of local element'
		MATCHING_ET='xs:%localElement'
		BREAK_PARENT_BLOCK='when-executed'
		<AREA>
			<CTRL_GROUP>
				FMT={
					txtfl.separator.type='none';
				}
				<CTRLS>
					<DATA_CTRL>
						EXPR='toXMLName (getServiceAttr("qName").toQName(),
           getArrayParam("$xmlContexts"))'
						<DOC_HLINK>
							TITLE_EXPR='getBooleanParam("show.linkTitle") ? callStockSection("Link Title")'
							TARGET_FRAME_EXPR='getStringParam("$targetFrame")'
							HKEYS={
								'contextElement.id';
								'getArrayParam("$linkDestKeys")';
							}
						</DOC_HLINK>
					</DATA_CTRL>
					<TEMPLATE_CALL_CTRL>
						COND='hasParamValue("show.elementNameExt", "always")
||
hasParamValue("show.elementNameExt", "repeating") &&
{
  qName = getServiceAttr("qName").toQName();

  mainXMLFilter = BooleanQuery (checkElementByKey (
                    "main-xmls",
                    getXMLDocument().id,
                    getElementParam("$mainXML"))
                  );

  countElementsByKey ("xsd-elements", qName, mainXMLFilter) > 1
}'
						TEMPLATE_FILE='../element/elementNameExt.tpl'
						PASSED_PARAMS={
							'$xmlContexts','Array (rootElement, contextElement)';
						}
						FMT={
							text.style='cs3';
							text.font.style.bold='false';
							text.hlink.fmt='style';
							text.hlink.style='cs4';
						}
					</TEMPLATE_CALL_CTRL>
				</CTRLS>
			</CTRL_GROUP>
		</AREA>
	</AREA_SEC>
	<AREA_SEC>
		DESCR='case of global complexType'
		MATCHING_ET='xs:complexType'
		BREAK_PARENT_BLOCK='when-executed'
		FMT={
			par.option.nowrap='true';
		}
		<AREA>
			<CTRL_GROUP>
				<CTRLS>
					<DATA_CTRL>
						COND='! getAttrBooleanValue ("abstract")'
						EXPR='toXMLName (getServiceAttr("qName").toQName(),
           getArrayParam("$xmlContexts"))'
						<DOC_HLINK>
							TITLE_EXPR='getBooleanParam("show.linkTitle") ? callStockSection("Link Title")'
							TARGET_FRAME_EXPR='getStringParam("$targetFrame")'
							HKEYS={
								'contextElement.id';
								'getArrayParam("$linkDestKeys")';
							}
						</DOC_HLINK>
					</DATA_CTRL>
					<DATA_CTRL>
						COND='getAttrBooleanValue ("abstract")'
						EXPR='toXMLName (getServiceAttr("qName").toQName(),
           getArrayParam("$xmlContexts"))'
						FMT={
							text.font.style.italic='true';
						}
						<DOC_HLINK>
							TITLE_EXPR='getBooleanParam("show.linkTitle") ? callStockSection("Link Title")'
							TARGET_FRAME_EXPR='getStringParam("$targetFrame")'
							HKEYS={
								'contextElement.id';
								'getArrayParam("$linkDestKeys")';
							}
						</DOC_HLINK>
					</DATA_CTRL>
					<SS_CALL_CTRL>
						COND='hasServiceAttr ("version")'
						SS_NAME='version'
						FMT={
							text.style='cs3';
							text.font.style.bold='false';
						}
					</SS_CALL_CTRL>
				</CTRLS>
			</CTRL_GROUP>
		</AREA>
	</AREA_SEC>
	<AREA_SEC>
		DESCR='any other (global) component'
		<AREA>
			<CTRL_GROUP>
				<CTRLS>
					<DATA_CTRL>
						EXPR='toXMLName (getServiceAttr("qName").toQName(),
           getArrayParam("$xmlContexts"))'
						<DOC_HLINK>
							TITLE_EXPR='getBooleanParam("show.linkTitle") ? callStockSection("Link Title")'
							TARGET_FRAME_EXPR='getStringParam("$targetFrame")'
							HKEYS={
								'contextElement.id';
								'getArrayParam("$linkDestKeys")';
							}
						</DOC_HLINK>
					</DATA_CTRL>
					<SS_CALL_CTRL>
						COND='hasServiceAttr ("version")'
						SS_NAME='version'
						FMT={
							text.style='cs3';
							text.font.style.bold='false';
						}
					</SS_CALL_CTRL>
				</CTRLS>
			</CTRL_GROUP>
		</AREA>
	</AREA_SEC>
</ROOT>
<STOCK_SECTIONS>
	<TEMPLATE_CALL>
		SS_NAME='Link Title'
		TEMPLATE_FILE='componentLinkTitle.tpl'
	</TEMPLATE_CALL>
	<AREA_SEC>
		SS_NAME='version'
		FMT={
			sec.outputStyle='text-par';
		}
		<AREA>
			<CTRL_GROUP>
				<CTRLS>
					<SEPARATOR>
					</SEPARATOR>
					<TEXT_CTRL>
						TEXT='(ver'
					</TEXT_CTRL>
					<SEPARATOR>
					</SEPARATOR>
					<DATA_CTRL>
						EXPR='getServiceAttr("version").toInt()'
					</DATA_CTRL>
					<SEPARATOR>
						FMT={
							txtfl.separator.type='none';
						}
					</SEPARATOR>
					<TEXT_CTRL>
						TEXT=')'
					</TEXT_CTRL>
				</CTRLS>
			</CTRL_GROUP>
		</AREA>
	</AREA_SEC>
</STOCK_SECTIONS>
CHECKSUM='0UGbxJD6Hc7GQiQS43HB+gkki3W74NRMr7q9k6Uxee4'
</FLEXDOCXYZ_TEMPLATE>