<FLEXDOCXYZ_TEMPLATE VER='1.23'>
CREATED='2005-04-26 03:31:00'
LAST_UPDATE='2021-11-28 13:49:11'
DESIGNER_TOOL='FlexDoc.XYZ SDK 1.x'
DESIGNER_LICENSE_TYPE='Filigris Works Team'
APP_ID='flexdoc-xml-wsdldoc'
APP_NAME='FlexDoc/XML WSDLDoc'
APP_VER='1.2.5'
APP_AUTHOR='Copyright © 2012-2021 Filigris Works, Leonid Rudy Softwareprodukte. All rights reserved.'
TEMPLATE_TYPE='DocumentTemplate'
DSM_TYPE_ID='wsdldoc'
ROOT_ETS={'xs:%element';'xs:complexType';'xs:group'}
<TEMPLATE_PARAMS>
	PARAM={
		param.name='$mainXML';
		param.type='GOMElement';
	}
	PARAM={
		param.name='$contentModelKey';
		param.title='map key for "xsd-content-model-element-defs"';
		param.description='The key by which the content elements are obtained from the "xsd-content-model-element-defs" element map';
		param.type='Object';
		param.defaultValue.expr='contextElement.id';
	}
	PARAM={
		param.name='$caption';
		param.type='string';
		param.defaultValue='Content Model Elements';
	}
	PARAM={
		param.name='doc.xsd.comp';
		param.title='XSD Component';
		param.title.style.bold='true';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='doc.xsd.comp.lists.layout';
		param.title='List Layout';
		param.title.style.italic='true';
		param.type='enum';
		param.enum.values='flow;one_column;two_columns;optimal';
	}
	PARAM={
		param.name='nav';
		param.title='Navigation';
		param.title.style.bold='true';
		param.group='true';
	}
	PARAM={
		param.name='nav.bar';
		param.title='Navigation Bar';
		param.type='boolean';
	}
	PARAM={
		param.name='show';
		param.title='Show';
		param.title.style.bold='true';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='show.elementNameExt';
		param.title='Element Name Extensions';
		param.type='enum';
		param.enum.values='always;repeating;never';
	}
	PARAM={
		param.name='page';
		param.title='Pagination';
		param.title.style.bold='true';
		param.group='true';
	}
	PARAM={
		param.name='page.refs';
		param.title='Generate page references';
		param.type='boolean';
		param.defaultValue='true';
	}
</TEMPLATE_PARAMS>
<STYLES>
	CHAR_STYLE={
		style.name='Component List';
		style.id='cs1';
		text.font.size='10';
	}
	PAR_STYLE={
		style.name='Component List Heading 1';
		style.id='ps1';
		text.font.name='Arial';
		text.font.size='10';
		text.font.style.bold='true';
		par.margin.top='10';
		par.margin.bottom='7';
		par.page.keepWithNext='true';
	}
	CHAR_STYLE={
		style.name='Default Paragraph Font';
		style.id='cs2';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Hyperlink';
		style.id='cs3';
		text.decor.underline='true';
		text.color.foreground='#0000FF';
	}
	PAR_STYLE={
		style.name='Normal';
		style.id='ps2';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Page Reference';
		style.id='cs4';
		text.font.name='Courier New';
		text.font.size='8';
	}
</STYLES>
FMT={
	doc.lengthUnits='pt';
	doc.hlink.style.link='cs3';
}
<ROOT>
	<FOLDER>
		COND='e = findElementsByKey (
      "xsd-content-model-elements",
      getParam("$contentModelKey")
    );

e.hasNext() ?
{
  nameExt = null;

  /* This variable accumulates the maximal normalized length of element display name.
   For an element, the normalized display name length is calculated
   as the number of characters of the element\'s main name plus the number of character
   of the element name extension multiplied by 0.8
  */
  nameLenMax = 0;

  mainXMLFilter = BooleanQuery (checkElementByKey (
                    "main-xmls",
                    getXMLDocument().id,
                    getElementParam("$mainXML")
                  ));

  v = e.toVector();

  v.sortVector (
     @(GOMElement) el,
     StringQuery ({
       qName = el.getServiceAttr("qName").toQName();

       displayName = toXMLName (qName, rootElement);
       nameLen = displayName.length();

       // if this is a local element and the name extension must be added
       (el.instanceOf("xs:%localElement")
        &&
        (hasParamValue("show.elementNameExt", "always")
         ||
         hasParamValue("show.elementNameExt", "repeating") &&
         countElementsByKey ("xsd-elements", qName, mainXMLFilter) > 1)
       ) ? {
         nameExt = el.callStockSection ("elementNameExt");
         displayName += nameExt;

         nameLen += round (nameExt.length() * 0.8);
       };

       nameLenMax < nameLen ? nameLenMax = nameLen;

       displayName
    }),
    false
  );

  thisContext.setVar ("elements", v);

  /* The actual list layout:

   - If the list consist of a single element, the layout is \'flow\'
   - If the specified layout was \'optimal\', calculate the actual layout as follows:

     1). If there are no local element name extensions, use \'flow\' layout
     2). If maximal normalized length of element display names in the list exceeds 50,
         use \'one_column\' layout
     3). Otherwise, use \'two_columns\' layout

   - Otherwise, use the specified layout
  */

  thisContext.setVar (
    "listLayout", 
    (v.size() == 1 ? "flow" :
       hasParamValue("doc.xsd.comp.lists.layout", "optimal") ?
         nameExt == null ? "flow" : nameLenMax > 50 ? "one_column" : "two_columns"
       : getStringParam("doc.xsd.comp.lists.layout"))
  );

  true;

} : false'
		<HTARGET>
			COND='getBooleanParam("nav.bar")'
			HKEYS={
				'contextElement.id';
				'"content-element-summary"';
			}
		</HTARGET>
		<HEADER>
			<AREA_SEC>
				FMT={
					par.style='ps1';
				}
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<DATA_CTRL>
								EXPR='getStringParam("$caption")'
							</DATA_CTRL>
							<DATA_CTRL>
								EXPR='"(" + thisContext.getVar ("elements").toVector().size() + ")"'
							</DATA_CTRL>
							<SEPARATOR>
								FMT={
									txtfl.separator.type='none';
								}
							</SEPARATOR>
							<TEXT_CTRL>
								TEXT=':'
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</HEADER>
		<BODY>
			<ELEMENT_ITER>
				DESCR='print the list as comma-delimited text flow'
				COND='thisContext.getVar ("listLayout") == "flow"'
				BREAK_PARENT_BLOCK='when-executed'
				TARGET_ET='xs:%element'
				SCOPE='custom'
				ELEMENT_ENUM_EXPR='thisContext.getVar ("elements").toEnum()'
				FMT={
					sec.outputStyle='list';
					sec.indent.block='true';
					text.style='cs1';
					list.type='delimited';
				}
				<BODY>
					<AREA_SEC>
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<SS_CALL_CTRL>
										SS_NAME='List Item'
									</SS_CALL_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</BODY>
			</ELEMENT_ITER>
			<ELEMENT_ITER>
				DESCR='print one-column list'
				COND='thisContext.getVar ("listLayout") == "one_column"'
				BREAK_PARENT_BLOCK='when-executed'
				TARGET_ET='xs:%element'
				SCOPE='custom'
				ELEMENT_ENUM_EXPR='thisContext.getVar ("elements").toEnum()'
				FMT={
					sec.indent.block='true';
				}
				<BODY>
					<AREA_SEC>
						FMT={
							text.style='cs1';
						}
						<AREA>
							<CTRL_GROUP>
								FMT={
									txtfl.separator.type='none';
								}
								<CTRLS>
									<SS_CALL_CTRL>
										SS_NAME='List Item'
									</SS_CALL_CTRL>
									<TEXT_CTRL>
										COND='! iterator.isLastItem'
										TEXT=','
									</TEXT_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</BODY>
			</ELEMENT_ITER>
			<FOLDER>
				DESCR='otherwise, print two column list'
				FMT={
					sec.indent.block='true';
				}
				<BODY>
					<AREA_SEC>
						FMT={
							sec.outputStyle='table';
							table.cell.padding.both='0';
							table.border.style='none';
						}
						<AREA>
							<CTRL_GROUP>
								FMT={
									trow.cell.align.vert='Top';
								}
								<CTRLS>
									<SS_CALL_CTRL>
										SS_NAME='List Column'
										PARAMS_EXPR='v = thisContext.getVar ("elements").toVector();
N = v.size();

Array (
  v.subVector (0, (N + 1) / 2),
  N == 1
)'
										FMT={
											ctrl.size.width='209.3';
											ctrl.size.height='18';
										}
									</SS_CALL_CTRL>
									<SS_CALL_CTRL>
										SS_NAME='List Column'
										PARAMS_EXPR='v = thisContext.getVar ("elements").toVector();

Array (
  v.subVector ((v.size() + 1) / 2),
  true
)'
										FMT={
											ctrl.size.width='272.3';
											ctrl.size.height='18';
											tcell.padding.extra.left='10';
										}
									</SS_CALL_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</BODY>
			</FOLDER>
		</BODY>
	</FOLDER>
</ROOT>
<STOCK_SECTIONS>
	<TEMPLATE_CALL>
		SS_NAME='elementNameExt'
		MATCHING_ET='xs:%localElement'
		TEMPLATE_FILE='elementNameExt.tpl'
		PASSED_PARAMS={
			'$xmlContexts','Array (rootElement, contextElement)';
		}
	</TEMPLATE_CALL>
	<ELEMENT_ITER>
		SS_NAME='List Column'
		DESCR='params[0]: vector of column elements; 
params[1]: true if this is the last part of the whole list (to avoid printing comma after last item)'
		TARGET_ET='xs:%element'
		SCOPE='custom'
		ELEMENT_ENUM_EXPR='toEnum (stockSection.param)'
		FMT={
			sec.outputStyle='pars';
			txtfl.separator.type='text';
			txtfl.separator.text=', ';
		}
		<BODY>
			<AREA_SEC>
				FMT={
					text.style='cs1';
				}
				<AREA>
					<CTRL_GROUP>
						FMT={
							txtfl.separator.type='none';
						}
						<CTRLS>
							<SS_CALL_CTRL>
								SS_NAME='List Item'
							</SS_CALL_CTRL>
							<TEXT_CTRL>
								COND='! iterator.isLastItem ||
! stockSection.params[1].toBoolean()'
								TEXT=','
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</BODY>
	</ELEMENT_ITER>
	<AREA_SEC>
		SS_NAME='List Item'
		MATCHING_ET='xs:%element'
		FMT={
			sec.outputStyle='text-par';
		}
		<AREA>
			<CTRL_GROUP>
				<CTRLS>
					<TEMPLATE_CALL_CTRL>
						TEMPLATE_FILE='../component/componentName.tpl'
						PASSED_PARAMS={
							'$xmlContexts','Array (rootElement)';
						}
					</TEMPLATE_CALL_CTRL>
					<PANEL>
						COND='output.format.supportsPageRefs
&&
getBooleanParam("page.refs")
&&
findHyperTarget (
  Array (
    contextElement.id,
    Array ("detail", "local", "def", "xml-source-location"),
    Array (NoKey(), rootElement.id, NoKey())
  )
) != null'
						FMT={
							ctrl.size.width='183';
							ctrl.size.height='38.3';
							txtfl.separator.type='none';
						}
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<SEPARATOR>
										FMT={
											txtfl.separator.type='nbsp';
										}
									</SEPARATOR>
									<TEXT_CTRL>
										TEXT='['
										FMT={
											text.style='cs4';
										}
									</TEXT_CTRL>
									<DATA_CTRL>
										DOCFIELD='page-htarget'
										FMT={
											ctrl.option.noHLinkFmt='true';
											text.style='cs4';
											text.hlink.fmt='none';
										}
										<DOC_HLINK>
											DESCR='first, try to reach the element\'s global documentation (if exists);
otherwise, try to link to the element\'s local documentation within the documentation of the current component (for which the content element list is generated);
if not found, link to such a section in the documentation of the element\'s parent component (where it is defined);
finally, if not found still, try to link to the definition location of this local element within the XML schema source'
											HKEYS={
												'contextElement.id';
												'Array ("detail", "local", "def", "xml-source-location")';
												'Array (NoKey(), rootElement.id, NoKey())';
											}
										</DOC_HLINK>
									</DATA_CTRL>
									<TEXT_CTRL>
										TEXT=']'
										FMT={
											text.style='cs4';
										}
									</TEXT_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</PANEL>
				</CTRLS>
			</CTRL_GROUP>
		</AREA>
	</AREA_SEC>
</STOCK_SECTIONS>
CHECKSUM='VcN1XlEKxgcP8sTUhK?UpJqr3B9Z4NV52AbkVG45e?g'
</FLEXDOCXYZ_TEMPLATE>